/*
*******************************************
*   Developed by Luiz Fernando Romanini   *
*******************************************
*/

#ifndef APPLICATION_H
#define APPLICATION_H

#include <map>
#include <string>

class Application
{
public:
	Application( );
	virtual ~Application( );
	static Application *getApplication( );

	void setApplicationName( const char *szApplicationName );

	void readArguments( int iArgCount, char *szArgValue[ ] );
	int getArgumentsCount( ) const;
	bool isArgumentSet( const std::string &strArgumentName ) const;
	std::string getArgumentValue( const std::string &strArgumentName ) const;

	virtual int main( ) = 0;
	const char * getVersion( ) const;

protected:
	static const char VERSION[ ];
	std::string strApplicationName;

private:
	static Application *hInstance;
	std::map < std::string, std::string > mapArgs;
};
#endif
