#ifndef SOCKET_H
#define SOCKET_H

#include <netdb.h>
#include <string>
#include <sys/socket.h>
#include <string>

class Socket
{
private:
	int iSock;
	sockaddr_in addr;

protected:
	Socket( );
	bool isValid( ) const;

public:
	static const int MAX_RECV;

	virtual ~Socket( );

	// Server initialization
	bool create( );
	bool bind( int iPort );
	bool listen( int iMaxConnections ) const;
	bool accept( Socket *s );

	// Client initialization
	bool connect( const std::string &strHost, int iPort );

	// Data transmission
	bool send( const std::string &strMessage ) const;
	int receive( std::string *strMessage ) const;

	void setNonBlocking( bool b );
	void disconnect( );
};
#endif
