/*
*******************************************
*   Developed by Luiz Fernando Romanini   *
*******************************************
*/

#include <cstdlib>
#include <iostream>

#include "Application.h"
#include "DateTime.h"
#include "Exception.h"

int main( int argc, char *argv[ ] )
{
	int iReturnCode = EXIT_SUCCESS;

	try
	{
		Application *application = Application::getApplication( );

		application->setApplicationName( argv[ 0 ] );
		application->readArguments( argc, argv );

		iReturnCode = application->main( );
	}
	catch( Exception e )
	{
		std::cerr << "[ " << DateTime::getCurrent( ) << " ] " << e.what( ) << std::endl;
		iReturnCode = EXIT_FAILURE;
	}
	catch( std::exception stde )
	{
		std::cerr << "[ " << DateTime::getCurrent( ) << " ] std::exception: " << stde.what( ) << std::endl;
		iReturnCode = EXIT_FAILURE;
	}
	catch( ... )
	{
		std::cerr << "[ " << DateTime::getCurrent( ) << " ] Unknow error!" << std::endl;
		iReturnCode = EXIT_FAILURE;
	}

	return iReturnCode;
}
