/*
*******************************************
*   Developed by Luiz Fernando Romanini   *
*******************************************
*/

#include <cmath>
//#include <iostream>

#include "VREPRobot.h"

const float VREPRobot::SPEED = 2;

VREPRobot::VREPRobot( simxInt simxClientId )
{
	this->simxClientId = simxClientId;
	this->strRobotName = "K3_robot";

	simxGetObjectHandle( this->simxClientId, this->strRobotName.c_str( ), &this->simxHandle, simx_opmode_oneshot_wait );

	simxGetObjectHandle( this->simxClientId, "K3_leftWheelMotor", &this->simxLeftWheelMotor, simx_opmode_oneshot_wait );
	simxGetObjectHandle( this->simxClientId, "K3_rightWheelMotor", &this->simxRightWheelMotor, simx_opmode_oneshot_wait );
}

VREPRobot::~VREPRobot( )
{
}

void VREPRobot::stop( ) const
{
	simxSetJointTargetVelocity( this->simxClientId, this->simxLeftWheelMotor, 0, simx_opmode_oneshot );
	simxSetJointTargetVelocity( this->simxClientId, this->simxRightWheelMotor, 0, simx_opmode_oneshot );
}

void VREPRobot::moveFront( ) const
{
	simxSetJointTargetVelocity( this->simxClientId, this->simxLeftWheelMotor, VREPRobot::SPEED, simx_opmode_oneshot );
	simxSetJointTargetVelocity( this->simxClientId, this->simxRightWheelMotor, VREPRobot::SPEED, simx_opmode_oneshot );
//	extApi_sleepMs( 500 );
}

void VREPRobot::moveLeft( ) const
{
	simxSetJointTargetVelocity( this->simxClientId, this->simxLeftWheelMotor, 0, simx_opmode_oneshot );
	simxSetJointTargetVelocity( this->simxClientId, this->simxRightWheelMotor, VREPRobot::SPEED, simx_opmode_oneshot );
//	extApi_sleepMs( 500 );
}

void VREPRobot::moveRight( ) const
{
	simxSetJointTargetVelocity( this->simxClientId, this->simxLeftWheelMotor, VREPRobot::SPEED, simx_opmode_oneshot );
	simxSetJointTargetVelocity( this->simxClientId, this->simxRightWheelMotor, 0, simx_opmode_oneshot );
//	extApi_sleepMs( 500 );
}

void VREPRobot::moveReverse( ) const
{
	simxSetJointTargetVelocity( this->simxClientId, this->simxLeftWheelMotor, VREPRobot::SPEED * -1, simx_opmode_oneshot );
	simxSetJointTargetVelocity( this->simxClientId, this->simxRightWheelMotor, VREPRobot::SPEED * -1, simx_opmode_oneshot );
//	extApi_sleepMs( 500 );
}

void VREPRobot::look( ) const
{
	simxInt simxVisionSensor;
	simxGetObjectHandle( this->simxClientId, "Vision_sensor", &simxVisionSensor, simx_opmode_oneshot_wait );
}

void VREPRobot::getItem( ) const
{
	simxInt simxLeftArm;
	simxInt simxRightArm;

	simxGetObjectHandle( this->simxClientId, "K3_gripper_armJoint1", &simxLeftArm, simx_opmode_oneshot_wait );
	simxGetObjectHandle( this->simxClientId, "K3_gripper_armJoint2", &simxRightArm, simx_opmode_oneshot_wait );

//	std::cout << "simxLeftArm " << simxLeftArm << std::endl;
//	std::cout << "simxRightArm " << simxRightArm << std::endl;

	simxSetJointTargetPosition( this->simxClientId, simxLeftArm, 2 * M_PI, simx_opmode_oneshot );
//	simxSetJointTargetPosition( this->simxClientId, simxRightArm, 3, simx_opmode_oneshot );

//K3_gripper_armJoint1
//K3_gripper_armJoint2
//K3_gripper_armAuxJoint1
//K3_gripper_armAuxJoint2
//K3_gripper_armAuxJoint3
//K3_gripper_armAuxJoint4
//K3_gripper_fingers
//K3_gripper_fingersAux
//K3_gripper_fingersAux0
//K3_gripper_leftColorSensor
//K3_gripper_rightColorSensor
//K3_stateVisualization
}
